#!/bin/bash

# Remove logs:
rm *.log* *.csv 2>/dev/null

# Client sockets:
entity_dflt=`cat .entity 2>/dev/null`
entityServerSessions_dflt=`cat .entityServerSessions 2>/dev/null`

echo
echo
# If all have values:
if [ "$entity_dflt" != ""  -a "$entityServerSessions_dflt" != "" ]
then
  echo "Do you wish to answer wizard commandline configuration ? (y/n) [n]:"
  read wizard
  [ "$wizard" = "" ] && wizard=n
  [ "$wizard" = "n" ] && exit
fi

# DEFAULTS
#[ "$entity_dflt" = "" ] && entity_dflt="192.168.12.11:3868,192.168.12.21:3868"
[ "$entity_dflt" = "" ] && entity_dflt="localhost:3868"
[ "$entityServerSessions_dflt" = "" ] && entityServerSessions_dflt=1

# Wizard

# As client:
echo "Diameter entity server sessions (0: diameter entity disabled) [$entityServerSessions_dflt]:"
read entityServerSessions
[ "$entityServerSessions" = "" ] && entityServerSessions=$entityServerSessions_dflt

entity=
if test "$entityServerSessions" != "0"
then
  echo "Target diameter entity (pipe-separated <ip|hostname>:<port> socket literal list) ["$entity_dflt"]:"
  read entity
fi
[ "$entity" = "" ] && entity="$entity_dflt"

# Configure:
cat services.msk \
  | sed 's/_ENTITY_/'$entity'/' \
  | sed 's/_ENTITY_SERVER_SESSIONS_/'$entityServerSessions'/' \
> services.xml

echo
echo

