// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_ServerSocket_hpp
#define anna_comm_handler_ServerSocket_hpp

#include <anna/comm/Handler.hpp>

namespace anna {

namespace comm {

class ServerSocket;
class LocalConnection;

namespace handler {


class ServerSocket : public Handler {
public:
  ServerSocket(Communicator* communicator) :
    Handler(communicator, Handler::Type::ServerSocket, Support::None),
    a_serverSocket(NULL)
  {;}

  void setup(comm::ServerSocket* serverSocket) throw() { a_serverSocket = serverSocket; }

private:
  comm::ServerSocket* a_serverSocket;

  void initialize() throw(RuntimeException) ;
  void apply() throw(RuntimeException);
  void breakAddress(const in_addr_t&) throw() ;
  void finalize() throw();

  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

