// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_dbms_mysql_ResultCode_hpp
#define anna_dbms_mysql_ResultCode_hpp

#include <anna/dbms/ResultCode.hpp>

#include <anna/dbms.mysql/forward.hpp>

namespace anna {

namespace dbms {

namespace mysql {

/**
   Clase para acceder a la informacion devuelta por el gestor de base de datos
   referente al ultimo comando realizado.
 */
class ResultCode : public dbms::ResultCode {
public:
  /**
     Constructor.
     \param mysql Instancia de la base de datos sobre la que aplicamos la sentencia SQL.
  */
  explicit ResultCode(st_mysql* mysql);

  /**
     Constructor.
     \param stmt Instancia de la sentencia ejecutada.
  */
  explicit ResultCode(st_mysql_stmt* stmt);

private:
  class ErrorDecoder : public dbms::ResultCode::ErrorDecoder {
    bool notFound(const int errorCode) const throw();
    bool successful(const int errorCode) const throw();
    bool locked(const int errorCode) const throw();
    bool lostConnection(const int errorCode) const throw();
  };

  static ErrorDecoder st_errorDecoder;
};

}
}
}

#endif

