// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_comm_ClassCode_hpp
#define anna_diameter_comm_ClassCode_hpp


// STL
#include <string>


namespace anna {

namespace diameter {

namespace comm {

/**
   Class types for request/answers managed by the module.
   No matter if we are client or server: request messages will be temporized, but not answers.
*/
struct ClassCode {
  enum _v {
    Undefined, /**< Internal use */ // valdra 0, igual que Min
    Bind, /**< Capabilities Exchange Request */
    ApplicationMessage, /**< Diameter messages (request/answers) to the server (answers not temporized) */
    Max, /**< Internal use */
    Min = 0 /**< Internal use */
  };


  /**
     Class type string representation
     \param v Class type code to translate.
     \return Class type string representation.
  */
  //static std::string asString(const _v v) throw();

  /**
     Class type text representation
     \param v Class type code to translate.
     \return Class type text representation.
  */
  static std::string asText(const _v v) throw();
};

}
}
}

#endif

