// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_ldap_ClassCode_hpp
#define anna_ldap_ClassCode_hpp

#include <string>

namespace anna {

namespace ldap {

/**
   Modela los tipos de clases para peticiones/respuestas definidas en el modulo.
*/
struct ClassCode {
  enum _v {
    Undefined, /**< No definida. Uso interno */
    Bind, /**< Peticion de Bind. Uso interno */
    Search, /**< Peticion de busqueda */
    Max, /**< Uso interno */
    Min = 0 /**< Uso interno */
  };

  /**
     Devuelve una cadena que identifica el tipo de clase.
     \param v Codigo de tipo de clase a traducir.
     \return Una cadena que identifica el tipo de clase.
  */
  static std::string asString(const _v v) throw();
};

}
}

#endif

