// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_ldap_Scope_hpp
#define anna_ldap_Scope_hpp

#include <anna/core/RuntimeException.hpp>
#include <anna/config/defines.hpp>
#include <anna/core/define.autoenum.hpp>

namespace anna {

namespace ldap {

/**
   Modela los ambitos de busqueda usados en las consultas LDAP.

   \see ldap::Search
*/
struct Scope {
  enum _v {
    None = -1, /**< Requerido por la declaracion automtica */
    Base, /**< Busca solo en el nivel indicado por el DN. */
    OneLevel, /**< Busca en el nivel indicado por el DN y sus dependencias inmediatas */
    SubTree  /**< Busca en el nivel indicador por el DN y todas sus dependencias */
  };

  anna_declare_enum(ldap::Scope);

  /**
     Devuelve una cadena que identifica el tipo de ambito.
     \param v Codigo de ambito a traducir.
     \return Una cadena que identifica el tipo de ambito.
  */
  static const char* asText(const Scope::_v v) throw(RuntimeException) {
    return asCString(v);
  }
};

}
}

#endif

