// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/functions.hpp>
#include <anna/core/tracing/Logger.hpp>

#include <anna/dbms/LongBlock.hpp>
#include <anna/dbms/OutputBind.hpp>

using namespace anna;
using namespace std;

void dbms::OutputBind::write() const
throw(RuntimeException, dbms::DatabaseException) {
  const dbms::Data& data = Bind::getData();

  if(data.getType() != Data::Type::LongBlock) {
    string msg("anna::dbms::OutputBind::write | ");
    msg += data.asString();
    msg += " | This method only can be called for anna::dbms::LongBlock types";
    throw RuntimeException(msg, ANNA_FILE_LOCATION);
  }

  LOGDEBUG(
    string msg("anna::dbms::OutputBind::write | ");
    msg += data.asString();
    Logger::debug(msg, ANNA_FILE_LOCATION);
  );
  do_write(reinterpret_cast <const dbms::LongBlock&>(data));
}


